
main:
  // loop added so program runs continuously
  while true
    gosub DrawEnvironment
    gosub CreateRobot
    gosub CreateGoal
    gosub FindGoal
  wend
end

CreateRobot:
  rLocate 30,30+random(540),90
  rInvisible GREEN,LIGHTBLUE
  rPen DOWN
return

FindGoal:  
  AtGoal = FALSE
  while not AtGoal
    call LookForGoal(seen)
    if seen 
      call MoveTowardGoal(AtGoal) // returns if blocked or at goal
      if not AtGoal then call AvoidObstacle()
    else
      call Wander()
    endif    
  wend
  setcolor black,white
  xyString 728,Ygoal-5, "Found"
  delay 4000
return 

sub Wander()
  blocked = FALSE
  rTurn -90+ random(180)
  for i=1 to 100+random(100)
    if not (rFeel()&14) 
      rForward 1
    else
      blocked = TRUE
      break
    endif
  next      
  if blocked then call AvoidObstacle()  
return 

sub MoveTowardGoal(&AtGoal)
  AtGoal = FALSE // assume not at goal
  // move forward until something is encountered
  rForward 2
  while not (rFeel()&14)
    rForward 1
  wend
  if rSense(LightBlue) then AtGoal=True
return

sub AvoidObstacle()
    CW = 1
    CCW = -1
    // use ONE of the two IF's below
    //if rFeel()&3
    if random(100)<50
      call FollowWall(CW)
    else
      call FollowWall(CCW)
    endif                    
return

sub FollowWall(dir)
  if dir = 1 // clockwise
    sensor = 1
  else
    sensor = 16
  endif
  while not(rFeel()&sensor)   // prevents stuck situation
    rTurn dir   
  wend
  for i=1 to 100+random(100)
    if not (rFeel()&14) then rForward 1    
    if rRange(dir*70)<49 then rTurn -dir
    if rRange(dir*70)>51 then rTurn dir     
  next
  rTurn -dir*50  
return

Sub LookForGoal(&seen)
  seen = FALSE                
  for a=1 to 360
    if rLook(0) = RED
      seen = TRUE
      break
    endif
    rTurn -1
  next
return
    
DrawEnvironment:
  clearscr
  rectangle 0,0,799,599,black
  // draw obstacles
  setcolor Blue,Blue
  for x=200 to 600 step 200
    for y=100 to 500 step 200
       if random(100)<70 then call MyCircle(x-25+random(50),y-25+random(50),20+random(30))
    next
  next
return
  
CreateGoal:
  Ygoal = 100+random(400)
  SetColor LightBlue,LightBlue
  call MyCircle(750,Ygoal,40)
  SetColor Red,Red
  call MyCircle(750,Ygoal,20)
return

Sub MyCircle(x,y,r)
  // module to make circles easier  
  circle x-r,y-r,x+r,y+r
return  
